#!/usr/bin/perl

use DBI;
use PNGgraph::pie;

require "security.pl";

$scandb=DBI->connect("DBI:mysql:netspear:$dbhost",$dbuser,$dbpass);


print "Content-type: text/html\n\n";
print "<html>\n";
print "<META HTTP-EQUIV=\"CACHE-CONTROL\" CONTENT=\"NO-CACHE\">";
print "<title>Report by Operating Systems</title>\n";
print "<body bgcolor=black text=#00FF00 link=#00FF00 vlink=#00FF00>\n";
print "<style>body,input,select,table {background: #000; color: #0F0; font-size: 12px; font-family: verdana, sans-serif; } input,select { border: 1px solid #0F0; padding: 2px; margin: 2px; } input:hover { background: #030; }</style>";
print "<a style=\"color: #000\" href=/cgi-bin/netspear/reports.pl><img src = /favicon.ico></a>";
print "<center><h2>Report by Operating Systems</h2>\n";

$sql="select count(distinct host_ip) from scan_data where OS rlike \"Windows\"";
$win=$scandb->prepare($sql);
$win->execute();
$numwin=$win->fetchrow_array();
$win->finish();
$sql="select count(distinct host_ip) from scan_data where OS rlike \"Linux\"";
$lin=$scandb->prepare($sql);
$lin->execute();
$numlin=$lin->fetchrow_array();
$lin->finish();
$sql="select count(distinct host_ip) from scan_data where OS rlike \"Mac\"";
$mac=$scandb->prepare($sql);
$mac->execute();
$nummac=$mac->fetchrow_array();
$mac->finish();

$sql="select count(distinct host_ip) from scan_data where OS rlike \"Cisco\"";
$cisco=$scandb->prepare($sql);
$cisco->execute();
$numcisco=$cisco->fetchrow_array();

$sql="select count(distinct host_ip) from scan_data where OS rlike \"Solaris\"";
$sun=$scandb->prepare($sql);
$sun->execute();
$numsun=$sun->fetchrow_array();

$sql="select count(distinct host_ip) from scan_data where OS rlike \"BSD\"";
$bsd=$scandb->prepare($sql);
$bsd->execute();
$numbsd=$bsd->fetchrow_array();

$sql="select count(distinct host_ip) from scan_data where OS not rlike \"Windows\" and OS not rlike \"Linux\" and OS not rlike \"BSD\" and OS not rlike \"Mac\" and OS not rlike \"Cisco\" and OS not rlike \"Solaris\"\;";
$other=$scandb->prepare($sql);
$other->execute();
$numother=$other->fetchrow_array();

@data = (
    ["Linux $numlin","Windows $numwin","Mac $nummac","Cisco $numcisco","Solaris $numsun","BSD $numbsd","Other $numother"],
    [$numlin,$numwin,$nummac,$numcisco,$numsun,$numbsd,$numother ]
);

$my_graph = new PNGgraph::pie( 300, 200 );

$my_graph->set(
        title => 'Operating Systems',
        axislabelclr => 'black',
        pie_height => 36,
);

$numtotal=$numwin+$numlin+$nummac+$nuimsun+$numcisco+$numbsd+$numother;
$wintot=$numwin/$numtotal*100;
$my_graph->plot_to_png( "/var/www/html/netspear/OS.png", \@data );
print "<center><img src=/netspear/OS.png>";
print "</center><p>";
print "Windows OS's: $numwin<br>\n";
print "Linux OS's: $numlin<br>\n";
print "Mac OS's: $nummac<br>\n";
print "Solaris OS's: $numsun<br>\n";
print "Cisco OS's: $numcisco<br>\n";
print "BSD OS's: $numbsd<br>\n";
print "Other: $numother<p>\n";
print "Total: $numtotal<p>\n";
