#!/usr/bin/perl

use CGI qw(:all);
use DBI;
use Net::IPv4Addr qw( ipv4_chkip );
use Geo::IP;

$gi = Geo::IP->new(GEOIP_STANDARD);

$debug=1;
if ($debug) { open (DEBUG, ">>/tmp/debug.txt"); }
if ($debug) { print DEBUG "DEBUG STARTED\n"; }

$a = new CGI;
@b = $a->param;

require "security.pl";
$scandb = DBI->connect("DBI:mysql:netspear:$dbhost",$dbuser,$dbpass);

if ($debug) { print DEBUG "@b\n"; }

print "Content-type: text/html\n\n";

foreach $c (@b) {
	if ($line = param("$c")) {
                chomp($line);
        	if ($debug) { print DEBUG "var:$c data:$line\n"; }
		if ($c eq "user") {
			$user = $line;
			if ($debug) { print DEBUG "user: found! $user\n"; }
		}
                if ($line =~ /Interesting ports on/) {
                        @someport = "";
                        ($some,$words,$here,$newip) = split(/ /,$line);
                        $newip =~ s/://g;
                        $host_ip = $newip;
			$host_ip = ipv4_chkip($host_ip);
			if ($debug) { print DEBUG "host: found! $host_ip\n"; }
                }
                if ($line =~ /[0-9]+\/tcp/) {
                        if ($line =~ /filtered/) { next; }
			if ($line =~ /closed/) { next; }
                        ($portinfo,$state,$service,@version) = split(/ +/,$line);
                        $version = "@version";
                        ($port,$protocol) = split(/\//, $portinfo);
                        chomp($host_ip);
                        chomp($port);
                        chomp($service);
                        chomp($version);
			$version =~ s/\'//g;
			$version =~ s/Network Associates ePolicy Orchestrator.+/Network Associates ePolicy Orchestrator/g;
			$version =~ s/Apple AFP.+/Apple AFP/g;
			$version =~ s/Samba smbd 3\.X .+/Samba smbd 3.X/g;
                        @someport[$portnum] = "$host_ip,$port,$service,$version";
                        $portnum = $portnum + 1;
			if ($debug) { print DEBUG "port $port: Found!\n"; }
		}
                if (($line =~ /OS details:/) || ($line =~ /Aggressive OS guesses/)) {
                        ($a,$OS) = split(/: /,$line);
			chomp($OS);
			if ($debug) { print DEBUG "OS Details Found!\n"; }
			$numports = @someport;
			if ($numports > 0) { write_sql(); }
               	}
	}
}

sub check_user {
        $sql = "select entries from userinfo where email = \"$user\" ";
	$entry=$scandb->prepare($sql);
	$entry->execute();
	if ($entries=$entry->fetchrow_array()) {
		$newnument=$entries++;
	}
	$entry->finish();
	$sql = "update userinfo set laston=\"$thedat\", entries=\"$newnument\" where email = \"$user\" ";
	$writ=$scandb->prepare($sql);
	if ($writ->execute()) { print "User has been updated\n"; }
	$writ->finish();
}

sub write_sql {
	check_host_exists();
        $thedat = getdate();
	$cc = $gi->country_code_by_addr($host_ip);
	if (! $cc) { $cc="\?\?"; }
	if ($debug) { print DEBUG "Getting Country Code $cc\n"; }
        for ($i = 0; $i <= $numports-1; $i++) {
                ($host_ip,$port,$service,$version) = split(/\,/, @someport[$i]);
                if (! $host_ip || ! $version) { next; }
		print DEBUG "$host_ip $service $version\n";
                $thisport=$scandb->prepare( "INSERT into scan_data (host_ip,port,service,version,OS,user,date_submitted,verified,country_code) values( '$host_ip','$port','$service','$version','$OS','$user','$thedat','$verified','$cc' );" );
		if ($debug) { print DEBUG "SQL Writing now!\n"; }
                if (! $thisport->execute()) { print "SQL Error!<p>\n"; exit; }
        }
}

sub check_host_exists() {
        $dahost = $scandb->prepare( "Select host_number from scan_data where host_ip=\"$host_ip\" ");
        $dahost->execute();
        while ($man=$dahost->fetchrow_array()) {
                $daho=$scandb->prepare( "delete from scan_data where host_number=\"$man\" ");
                $daho->execute();
                $daho->finish();
                $host_exists=1;
        }
	if (($debug) && ($host_exists)) { print DEBUG "Host Already Existed!\n"; }
        $dahost->finish();
}

sub getdate {
	if ($debug) { print DEBUG "Getting Date!\n"; }
        open (DATE, "date +%d/%m/%y |");
	while (<DATE>) {
		$a = $_;
	}
        return "$a";
}
